#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DEFERRED_HOST_OPERATIONS_SPEC_VERSION")]
pub const KHR_DEFERRED_HOST_OPERATIONS_SPEC_VERSION: u32 = 4;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME")]
pub const KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_deferred_host_operations");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CREATE_DEFERRED_OPERATION_KHR: *const std::os::raw::c_char = crate::cstr!("vkCreateDeferredOperationKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_DESTROY_DEFERRED_OPERATION_KHR: *const std::os::raw::c_char = crate::cstr!("vkDestroyDeferredOperationKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_DEFERRED_OPERATION_MAX_CONCURRENCY_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetDeferredOperationMaxConcurrencyKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_DEFERRED_OPERATION_RESULT_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetDeferredOperationResultKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_DEFERRED_OPERATION_JOIN_KHR: *const std::os::raw::c_char = crate::cstr!("vkDeferredOperationJoinKHR");
crate::non_dispatchable_handle!(DeferredOperationKHR, DEFERRED_OPERATION_KHR, "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDeferredOperationKHR.html)) · Non-dispatchable Handle <br/> VkDeferredOperationKHR - A deferred operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DeferredOperationKHR`] handle is defined as:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVK_DEFINE_NON_DISPATCHABLE_HANDLE(VkDeferredOperationKHR)\n```\n[](#_description)Description\n----------\n\nThis handle refers to a tracking structure which manages the execution state\nfor a deferred command.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeviceLoader::build_acceleration_structures_khr`], [`crate::vk::DeviceLoader::copy_acceleration_structure_khr`], [`crate::vk::DeviceLoader::copy_acceleration_structure_to_memory_khr`], [`crate::vk::DeviceLoader::copy_memory_to_acceleration_structure_khr`], [`crate::vk::DeviceLoader::create_deferred_operation_khr`], [`crate::vk::DeviceLoader::create_ray_tracing_pipelines_khr`], [`crate::vk::DeviceLoader::deferred_operation_join_khr`], [`crate::vk::DeviceLoader::destroy_deferred_operation_khr`], [`crate::vk::DeviceLoader::get_deferred_operation_max_concurrency_khr`], [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`]\n", "VkDeferredOperationKHR");
#[doc = "Provided by [`crate::extensions::khr_deferred_host_operations`]"]
impl crate::vk1_0::Result {
    pub const THREAD_IDLE_KHR: Self = Self(1000268000);
    pub const THREAD_DONE_KHR: Self = Self(1000268001);
    pub const OPERATION_DEFERRED_KHR: Self = Self(1000268002);
    pub const OPERATION_NOT_DEFERRED_KHR: Self = Self(1000268003);
}
#[doc = "Provided by [`crate::extensions::khr_deferred_host_operations`]"]
impl crate::vk1_0::ObjectType {
    pub const DEFERRED_OPERATION_KHR: Self = Self(1000268000);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateDeferredOperationKHR.html)) · Function <br/> vkCreateDeferredOperationKHR - Create a deferred operation handle\n[](#_c_specification)C Specification\n----------\n\nTo construct the tracking object for a deferred command, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkCreateDeferredOperationKHR(\n    VkDevice                                    device,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDeferredOperationKHR*                     pDeferredOperation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns `operation`.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* [`Self::p_deferred_operation`] is a pointer to a handle in which the created[`crate::vk::DeferredOperationKHR`] is returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateDeferredOperationKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateDeferredOperationKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateDeferredOperationKHR-pDeferredOperation-parameter  \n  [`Self::p_deferred_operation`] **must** be a valid pointer to a [`crate::vk::DeferredOperationKHR`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCreateDeferredOperationKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, p_allocator: *const crate::vk1_0::AllocationCallbacks, p_deferred_operation: *mut crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyDeferredOperationKHR.html)) · Function <br/> vkDestroyDeferredOperationKHR - Destroy a deferred operation handle\n[](#_c_specification)C Specification\n----------\n\nWhen a deferred operation is completed, the application **can** destroy the\ntracking object by calling:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nvoid vkDestroyDeferredOperationKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the completed operation to be destroyed.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03434  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::operation`] was\n  created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03435  \n   If no [`crate::vk::AllocationCallbacks`] were provided when [`Self::operation`] was\n  created, [`Self::p_allocator`] **must** be `NULL`\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03436  \n  [`Self::operation`] **must** be completed\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyDeferredOperationKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-parameter  \n   If [`Self::operation`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkDestroyDeferredOperationKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-parent  \n   If [`Self::operation`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::operation`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkDestroyDeferredOperationKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR, p_allocator: *const crate::vk1_0::AllocationCallbacks) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeferredOperationMaxConcurrencyKHR.html)) · Function <br/> vkGetDeferredOperationMaxConcurrencyKHR - Query the maximum concurrency on a deferred operation\n[](#_c_specification)C Specification\n----------\n\nTo query the number of additional threads that can usefully be joined to a\ndeferred operation, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nuint32_t vkGetDeferredOperationMaxConcurrencyKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the deferred operation to be queried.\n[](#_description)Description\n----------\n\nThe returned value is the maximum number of threads that can usefully\nexecute a deferred operation concurrently, reported for the state of the\ndeferred operation at the point this command is called.\nThis value is intended to be used to better schedule work onto available\nthreads.\nApplications **can** join any number of threads to the deferred operation and\nexpect it to eventually complete, though excessive joins **may** return[`crate::vk::Result::THREAD_DONE_KHR`] immediately, performing no useful work.\n\nIf [`Self::operation`] is complete,[`crate::vk::DeviceLoader::get_deferred_operation_max_concurrency_khr`] returns zero.\n\nIf [`Self::operation`] is currently joined to any threads, the value returned by\nthis command **may** immediately be out of date.\n\nIf [`Self::operation`] is pending, implementations **must** not return zero unless\nat least one thread is currently executing [`crate::vk::DeviceLoader::deferred_operation_join_khr`]on [`Self::operation`].\nIf there are such threads, the implementation **should** return an estimate of\nthe number of additional threads which it could profitably use.\n\nImplementations **may** return 2<sup>32</sup>-1 to indicate that the maximum\nconcurrency is unknown and cannot be easily derived.\nImplementations **may** return values larger than the maximum concurrency\navailable on the host CPU.\nIn these situations, an application **should** clamp the return value rather\nthan oversubscribing the machine.\n\n|   |Note<br/><br/>The recommended usage pattern for applications is to query this value once,<br/>after deferral, and schedule no more than the specified number of threads to<br/>join the operation.<br/>Each time a joined thread receives [`crate::vk::Result::THREAD_IDLE_KHR`], the application<br/>should schedule an additional join at some point in the future, but is not<br/>required to do so.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetDeferredOperationMaxConcurrencyKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> u32;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeferredOperationResultKHR.html)) · Function <br/> vkGetDeferredOperationResultKHR - Query the result of a deferred operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] function is defined as:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkGetDeferredOperationResultKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the operation whose deferred result is being queried.\n[](#_description)Description\n----------\n\nIf no command has been deferred on [`Self::operation`],[`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] returns [`crate::vk::Result::SUCCESS`].\n\nIf the deferred operation is pending, [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`]returns [`crate::vk::Result::NOT_READY`].\n\nIf the deferred operation is complete, it returns the appropriate return\nvalue from the original command.\nThis value **must** be one of the [`crate::vk::Result`] values which could have been\nreturned by the original command if the operation had not been deferred.\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeferredOperationResultKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeferredOperationResultKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkGetDeferredOperationResultKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::NOT_READY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetDeferredOperationResultKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDeferredOperationJoinKHR.html)) · Function <br/> vkDeferredOperationJoinKHR - Assign a thread to a deferred operation\n[](#_c_specification)C Specification\n----------\n\nTo assign a thread to a deferred operation, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkDeferredOperationJoinKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the deferred operation that the calling thread should\n  work on.\n[](#_description)Description\n----------\n\nThe [`crate::vk::DeviceLoader::deferred_operation_join_khr`] command will execute a portion of the\ndeferred operation on the calling thread.\n\nThe return value will be one of the following:\n\n* A return value of [`crate::vk::Result::SUCCESS`] indicates that [`Self::operation`] is\n  complete.\n  The application **should** use [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] to\n  retrieve the result of [`Self::operation`].\n\n* A return value of [`crate::vk::Result::THREAD_DONE_KHR`] indicates that the deferred\n  operation is not complete, but there is no work remaining to assign to\n  threads.\n  Future calls to [`crate::vk::DeviceLoader::deferred_operation_join_khr`] are not necessary and\n  will simply harm performance.\n  This situation **may** occur when other threads executing[`crate::vk::DeviceLoader::deferred_operation_join_khr`] are about to complete [`Self::operation`],\n  and the implementation is unable to partition the workload any further.\n\n* A return value of [`crate::vk::Result::THREAD_IDLE_KHR`] indicates that the deferred\n  operation is not complete, and there is no work for the thread to do at\n  the time of the call.\n  This situation **may** occur if the operation encounters a temporary\n  reduction in parallelism.\n  By returning [`crate::vk::Result::THREAD_IDLE_KHR`], the implementation is signaling\n  that it expects that more opportunities for parallelism will emerge as\n  execution progresses, and that future calls to[`crate::vk::DeviceLoader::deferred_operation_join_khr`] **can** be beneficial.\n  In the meantime, the application **can** perform other work on the calling\n  thread.\n\nImplementations **must** guarantee forward progress by enforcing the following\ninvariants:\n\n1. If only one thread has invoked [`crate::vk::DeviceLoader::deferred_operation_join_khr`] on a\n   given operation, that thread **must** execute the operation to completion\n   and return [`crate::vk::Result::SUCCESS`].\n\n2. If multiple threads have concurrently invoked[`crate::vk::DeviceLoader::deferred_operation_join_khr`] on the same operation, then at least\n   one of them **must** complete the operation and return [`crate::vk::Result::SUCCESS`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkDeferredOperationJoinKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDeferredOperationJoinKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkDeferredOperationJoinKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::THREAD_DONE_KHR`]\n\n* [`crate::vk::Result::THREAD_IDLE_KHR`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkDeferredOperationJoinKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> crate::vk1_0::Result;
#[doc = "Provided by [`crate::extensions::khr_deferred_host_operations`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateDeferredOperationKHR.html)) · Function <br/> vkCreateDeferredOperationKHR - Create a deferred operation handle\n[](#_c_specification)C Specification\n----------\n\nTo construct the tracking object for a deferred command, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkCreateDeferredOperationKHR(\n    VkDevice                                    device,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDeferredOperationKHR*                     pDeferredOperation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns `operation`.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* [`Self::p_deferred_operation`] is a pointer to a handle in which the created[`crate::vk::DeferredOperationKHR`] is returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateDeferredOperationKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateDeferredOperationKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateDeferredOperationKHR-pDeferredOperation-parameter  \n  [`Self::p_deferred_operation`] **must** be a valid pointer to a [`crate::vk::DeferredOperationKHR`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkCreateDeferredOperationKHR")]
    pub unsafe fn create_deferred_operation_khr(&self, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> crate::utils::VulkanResult<crate::extensions::khr_deferred_host_operations::DeferredOperationKHR> {
        let _function = self.create_deferred_operation_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut deferred_operation = Default::default();
        let _return = _function(
            self.handle,
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
            &mut deferred_operation,
        );
        crate::utils::VulkanResult::new(_return, deferred_operation)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyDeferredOperationKHR.html)) · Function <br/> vkDestroyDeferredOperationKHR - Destroy a deferred operation handle\n[](#_c_specification)C Specification\n----------\n\nWhen a deferred operation is completed, the application **can** destroy the\ntracking object by calling:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nvoid vkDestroyDeferredOperationKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the completed operation to be destroyed.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03434  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::operation`] was\n  created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03435  \n   If no [`crate::vk::AllocationCallbacks`] were provided when [`Self::operation`] was\n  created, [`Self::p_allocator`] **must** be `NULL`\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-03436  \n  [`Self::operation`] **must** be completed\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyDeferredOperationKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-parameter  \n   If [`Self::operation`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkDestroyDeferredOperationKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyDeferredOperationKHR-operation-parent  \n   If [`Self::operation`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::operation`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkDestroyDeferredOperationKHR")]
    pub unsafe fn destroy_deferred_operation_khr(&self, operation: Option<crate::extensions::khr_deferred_host_operations::DeferredOperationKHR>, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> () {
        let _function = self.destroy_deferred_operation_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(
            self.handle,
            match operation {
                Some(v) => v,
                None => Default::default(),
            },
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
        );
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeferredOperationMaxConcurrencyKHR.html)) · Function <br/> vkGetDeferredOperationMaxConcurrencyKHR - Query the maximum concurrency on a deferred operation\n[](#_c_specification)C Specification\n----------\n\nTo query the number of additional threads that can usefully be joined to a\ndeferred operation, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nuint32_t vkGetDeferredOperationMaxConcurrencyKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the deferred operation to be queried.\n[](#_description)Description\n----------\n\nThe returned value is the maximum number of threads that can usefully\nexecute a deferred operation concurrently, reported for the state of the\ndeferred operation at the point this command is called.\nThis value is intended to be used to better schedule work onto available\nthreads.\nApplications **can** join any number of threads to the deferred operation and\nexpect it to eventually complete, though excessive joins **may** return[`crate::vk::Result::THREAD_DONE_KHR`] immediately, performing no useful work.\n\nIf [`Self::operation`] is complete,[`crate::vk::DeviceLoader::get_deferred_operation_max_concurrency_khr`] returns zero.\n\nIf [`Self::operation`] is currently joined to any threads, the value returned by\nthis command **may** immediately be out of date.\n\nIf [`Self::operation`] is pending, implementations **must** not return zero unless\nat least one thread is currently executing [`crate::vk::DeviceLoader::deferred_operation_join_khr`]on [`Self::operation`].\nIf there are such threads, the implementation **should** return an estimate of\nthe number of additional threads which it could profitably use.\n\nImplementations **may** return 2<sup>32</sup>-1 to indicate that the maximum\nconcurrency is unknown and cannot be easily derived.\nImplementations **may** return values larger than the maximum concurrency\navailable on the host CPU.\nIn these situations, an application **should** clamp the return value rather\nthan oversubscribing the machine.\n\n|   |Note<br/><br/>The recommended usage pattern for applications is to query this value once,<br/>after deferral, and schedule no more than the specified number of threads to<br/>join the operation.<br/>Each time a joined thread receives [`crate::vk::Result::THREAD_IDLE_KHR`], the application<br/>should schedule an additional join at some point in the future, but is not<br/>required to do so.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkGetDeferredOperationMaxConcurrencyKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkGetDeferredOperationMaxConcurrencyKHR")]
    pub unsafe fn get_deferred_operation_max_concurrency_khr(&self, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> u32 {
        let _function = self.get_deferred_operation_max_concurrency_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, operation as _);
        _return
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeferredOperationResultKHR.html)) · Function <br/> vkGetDeferredOperationResultKHR - Query the result of a deferred operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] function is defined as:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkGetDeferredOperationResultKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the operation whose deferred result is being queried.\n[](#_description)Description\n----------\n\nIf no command has been deferred on [`Self::operation`],[`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] returns [`crate::vk::Result::SUCCESS`].\n\nIf the deferred operation is pending, [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`]returns [`crate::vk::Result::NOT_READY`].\n\nIf the deferred operation is complete, it returns the appropriate return\nvalue from the original command.\nThis value **must** be one of the [`crate::vk::Result`] values which could have been\nreturned by the original command if the operation had not been deferred.\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeferredOperationResultKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeferredOperationResultKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkGetDeferredOperationResultKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::NOT_READY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkGetDeferredOperationResultKHR")]
    pub unsafe fn get_deferred_operation_result_khr(&self, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> crate::utils::VulkanResult<()> {
        let _function = self.get_deferred_operation_result_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, operation as _);
        crate::utils::VulkanResult::new(_return, ())
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDeferredOperationJoinKHR.html)) · Function <br/> vkDeferredOperationJoinKHR - Assign a thread to a deferred operation\n[](#_c_specification)C Specification\n----------\n\nTo assign a thread to a deferred operation, call:\n\n```\n// Provided by VK_KHR_deferred_host_operations\nVkResult vkDeferredOperationJoinKHR(\n    VkDevice                                    device,\n    VkDeferredOperationKHR                      operation);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the device which owns [`Self::operation`].\n\n* [`Self::operation`] is the deferred operation that the calling thread should\n  work on.\n[](#_description)Description\n----------\n\nThe [`crate::vk::DeviceLoader::deferred_operation_join_khr`] command will execute a portion of the\ndeferred operation on the calling thread.\n\nThe return value will be one of the following:\n\n* A return value of [`crate::vk::Result::SUCCESS`] indicates that [`Self::operation`] is\n  complete.\n  The application **should** use [`crate::vk::DeviceLoader::get_deferred_operation_result_khr`] to\n  retrieve the result of [`Self::operation`].\n\n* A return value of [`crate::vk::Result::THREAD_DONE_KHR`] indicates that the deferred\n  operation is not complete, but there is no work remaining to assign to\n  threads.\n  Future calls to [`crate::vk::DeviceLoader::deferred_operation_join_khr`] are not necessary and\n  will simply harm performance.\n  This situation **may** occur when other threads executing[`crate::vk::DeviceLoader::deferred_operation_join_khr`] are about to complete [`Self::operation`],\n  and the implementation is unable to partition the workload any further.\n\n* A return value of [`crate::vk::Result::THREAD_IDLE_KHR`] indicates that the deferred\n  operation is not complete, and there is no work for the thread to do at\n  the time of the call.\n  This situation **may** occur if the operation encounters a temporary\n  reduction in parallelism.\n  By returning [`crate::vk::Result::THREAD_IDLE_KHR`], the implementation is signaling\n  that it expects that more opportunities for parallelism will emerge as\n  execution progresses, and that future calls to[`crate::vk::DeviceLoader::deferred_operation_join_khr`] **can** be beneficial.\n  In the meantime, the application **can** perform other work on the calling\n  thread.\n\nImplementations **must** guarantee forward progress by enforcing the following\ninvariants:\n\n1. If only one thread has invoked [`crate::vk::DeviceLoader::deferred_operation_join_khr`] on a\n   given operation, that thread **must** execute the operation to completion\n   and return [`crate::vk::Result::SUCCESS`].\n\n2. If multiple threads have concurrently invoked[`crate::vk::DeviceLoader::deferred_operation_join_khr`] on the same operation, then at least\n   one of them **must** complete the operation and return [`crate::vk::Result::SUCCESS`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkDeferredOperationJoinKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDeferredOperationJoinKHR-operation-parameter  \n  [`Self::operation`] **must** be a valid [`crate::vk::DeferredOperationKHR`] handle\n\n* []() VUID-vkDeferredOperationJoinKHR-operation-parent  \n  [`Self::operation`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::THREAD_DONE_KHR`]\n\n* [`crate::vk::Result::THREAD_IDLE_KHR`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeferredOperationKHR`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkDeferredOperationJoinKHR")]
    pub unsafe fn deferred_operation_join_khr(&self, operation: crate::extensions::khr_deferred_host_operations::DeferredOperationKHR) -> crate::utils::VulkanResult<()> {
        let _function = self.deferred_operation_join_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, operation as _);
        crate::utils::VulkanResult::new(_return, ())
    }
}
